Subject: Re: [PATCH] powerpc: Create "rom" (MTD) device prpmc2800

From: Segher Boessenkool <[email-masked]>
Date: Sun, 3 Jun 2007 21:56:31 +0200

>>>> You obviously completely misunderstand the semantics
>>>> of the "compatible" property.
>
>>>    Oh well, on the chip level, your "compatible" prop would be 
>>> correct.
>
>> This has nothing to do with a "chip level", it is plain and
>> simply the most basic device tree stuff.
>
>    If it was as "plain and simple" as you say, there would be nothing 
> to argue about.

There isn't as far as I am concerned; the purpose and
meaning of the "compatible" property, as well as of any
other standard OF properties, is clear.

> What we ended up with is 2 or 3 level hierarchy of nodes which doesn't 
> at all seem to be such simple (considering the fact that what's 
> covered by a the simple "bank-width" property could be represented by 
> several combinations of interleaved flash chips).

Yes, the more complex (and sometimes insane) ways that
flash chips are connected to systems can be really hard
to describe properly.  Which is why I don't even want
to make a "binding" for it (yet).  It seems easy enough
to do this for single flash chips (possibly direct-mapped)
though.

> So, what you wanted us to do was either substantially redesign Linux 
> MTD subsys to fit it into that model

Nah.  The current MTD model has some issues of course,
but that is a separate problem.

>  (either that or over-engineer the physmap_of driver to gather that 
> kind of information from the multiple "chip" subnodes).

I would say it is overengineered already.  It shouldn't
try to be a general solution for all possible cases since
it has no hope of achieving that.  Get the simple cases
(that actually are used in real life) right, first.

Segher